
var editingArrayID = 0;

function printDosingPumpsWidget(){  // dashboard section
    // calibrateDoser(1);
    // return;

    $('#dashboardDoseContainer').empty();  // clear dosing pumps widget     
    
    for (var i=0; i < doseID.length; i++)  // draw a reservoir for each dosing pump
    {
        doseRemaining[i] = Math.floor((doseReservoirRemain[i] / doseAmount[i]));
        
        document.getElementById('dashboardDoseContainer').innerHTML +=
        '<div class="doseSettingsBox2">\
            <div class="doseNameDiv">' + doseName[i] + '</div>\
            <div class="doseSettingsTubeDiv" id="doseTubeDiv_' + i + '">\
                <span id="doseRemainingDiv_' + i + '">' + doseRemaining[i] + '</span></br>\
                <div id="doseClickColor_' + i + '"></div>\
                <img class="reservoirImage" height="130px;" src="images/icons/doseReservoir_White.png">\
            </div>\
        </div>';
    }

    for (var i=0; i < doseID.length; i++)  // calculate reservoir amount and fill
    {
        $('#doseTubeDiv_' + [i]).css('background','linear-gradient(90deg, ' + doseReservoirColor[i] + ' 100%, white 00%)');
        $('#doseTubeDiv_' + [i]).css('background-repeat', 'no-repeat');
        doseFillReservoirSettings(i);
    }
}

function dosingSettings() {  // main settings screen
    console.log('dosingSettings =============== '); 
    
    printHeaderTitle("DOSING PUMPS", "schedules3.png", "#8a5d23");  // name and file
    removeFooter();

    document.getElementById('content').innerHTML +=
        '<div class="cleanScreen" id="cleanScreen">\
        <div class="dosingPumpsBoxContainer" id="dosingPumpsBoxContainer"></div>\
        </div>';
        
    for (var i=0; i < doseID.length; i++)  // draw a reservoir for each dosing pump
    {
        doseRemaining[i] = Math.floor((doseReservoirRemain[i] / doseAmount[i]));

        document.getElementById('dosingPumpsBoxContainer').innerHTML +=
        '<div class="doseSettingsBox" id="doseContainer_' + i + '">\
            <div class="doseSettingsName" id="doseSettingsName_' + i + '">\
                ' + doseName[i] + '<i class="bi bi-pencil-fill editPencil" onclick="changeDosingName(' + i + ')"></i>\
            </div>\
            <div class="doseSettingsBox3">\
                <div class="doseSettingsAmountBox">\
                    <div class="doseSettingsAmountLabel">Dose Amount</div>\
                    <div class="doseSettingsAmount" id="doseSettingsAmount_' + i + '">' + doseAmount[i] +  ' ml</div>\
                </div>\
                <div class="parameterButtonBox">\
                    <button id="changeDoseAmountUp_' + i + '" onmousedown="changeDoseAmount(0,' + i + ')" class="doseUpDownButton bi bi-arrow-up-short"></button></br>\
                    <button id="changeDoseAmountDown_' + i + '" onmousedown="changeDoseAmount(1,' + i + ')" class="doseUpDownButton bi bi-arrow-down-short"></button>\
                </div>\
            </div>\
            <div class="doseSettingsBox3">\
                <div style="margin-top:5px;" class="doseSettingsTubeDiv" id="doseTubeDiv_' + i + '">\
                    <span id="doseRemainingDiv_' + i + '" class="dosesRemaining">' + doseRemaining[i] + ' Doses Remaining</span></br>\
                    <div data-jscolor="{value:`' + doseReservoirColor[i] + '`, onInput:`changeReservoirColor(this,' + i + ')`, onChange:`saveReservoirColor(this,' + i + ')`}" id="doseClickColor_' + i + '" class="jscolor_' + i + ' jscolorBackground"></div>\
                    <img class="reservoirImage" height="130px;" src="images/icons/doseReservoir_White.png">\
                    <div style="float:right">\
                        <div class="doseSettingsButton buttonHover" onclick="refillDoseReservoir(' + i + ')">Refill</div>\
                        <div class="doseSettingsButton buttonHover" onclick="manualDose(' + i + ')">Dose</div>\
                        <div class="doseSettingsButton buttonHover" onclick="dosingSettings2()">More Settings</div>\
                    </div>\
                </div>\
            </div>\
            </div>\
        </div>';
    }

    document.getElementById('cleanScreen').innerHTML +=
        '<div class="widgetButtonBox">\
            <button class="button _48 back_48" style="margin-top:40px;" type="button" onclick="viewSettingsMenu()"></button>\
            <button class="button _48 home_48" style="margin-top:40px;" type="button" onclick="loadLayout()"></button>\
        </div>';

    for (var i=0; i < doseID.length; i++)  // calculate reservoir amount and fill
    {
        jscolor.install(); // recognizes new inputs and installs jscolor on them
        $('#doseTubeDiv_' + [i]).css('background','linear-gradient(90deg, ' + doseReservoirColor[i] + ' 100%, white 00%)');
        $('#doseTubeDiv_' + [i]).css('background-repeat', 'no-repeat');

        doseFillReservoirSettings(i);

        var timeout;  // timer to track when button is held up or down
        var count = 0;
        var adjusted = 0;
        $('#changeDoseAmountUp_' + i).mousedown(function () {  // action to take when mouse is down every 150ms
            // timeout = setInterval(function () {changeDoseAmount(0, editingArrayID);}, 150);
            timeout = setInterval(function () {
                adjusted = 1;
                changeDoseAmount(0, editingArrayID);
                count++;  // count each cycle while mouse button is down
                if (count > 10) {  // after 10 cycles increase cycle speed to 50ms
                    clearInterval(timeout); 
                    timeout = setInterval(function () {
                        changeDoseAmount(0, editingArrayID);
                        count++;
                        if (count > 60) {  // after 60 cycles increase cycle speed to 1ms
                            clearInterval(timeout);
                            timeout = setInterval(function () {
                                changeDoseAmount(0, editingArrayID);
                            }, 1);
                        }
                    }, 50);
                }
            }, 150);
        }).mouseup(function () {  // stop action when mouse is up
            count = 0;
            adjusted = 0;
            saveDoseAmount();
            clearInterval(timeout);
        }).mouseout(function () {  // stop action when mouse moves off up/down button
            count = 0;
            if (adjusted == 1) {saveDoseAmount();}
            adjusted = 0;
            clearInterval(timeout);
        });
        
        $('#changeDoseAmountDown_' + i).mousedown(function () {  // action to take when mouse is down every 150ms
            // timeout = setInterval(function () {changeDoseAmount(1, editingArrayID);}, 150);
            timeout = setInterval(function () {
                adjusted = 1;
                changeDoseAmount(1, editingArrayID);
                count++;  // count each cycle while mouse button is down
                if (count > 10) {  // after 10 cycles increase cycle speed to 50ms
                    clearInterval(timeout); 
                    timeout = setInterval(function () {
                        changeDoseAmount(1, editingArrayID);
                        count++;
                        // if (count > 60) {  // after 60 cycles increase cycle speed to 1ms
                        //     clearInterval(timeout);
                        //     timeout = setInterval(function () {
                        //         changeDoseAmount(1, editingArrayID);
                        //     }, 1);
                        // }
                    }, 50);
                }
            }, 150);
        }).mouseup(function () {  // stop action when mouse is up
            count = 0;
            adjusted = 0;
            saveDoseAmount();
            clearInterval(timeout);
        }).mouseout(function () {  // stop action when mouse moves off up/down button
            count = 0;
            if (adjusted == 1) {saveDoseAmount();}
            adjusted = 0;
            clearInterval(timeout);
        });
    }
}

function dosingSettings2() {  // alternate  settings screen
    removeFooter();

    document.getElementById('content').innerHTML +=
        '<div class="cleanScreen" id="cleanScreen">\
        <div class="dosingPumpsBoxContainer" id="dosingPumpsBoxContainer"></div>\
        </div>';

    for (var i=0; i < doseID.length; i++)  // draw a reservoir for each dosing pump
    {
        document.getElementById('dosingPumpsBoxContainer').innerHTML +=
        '<div class="doseSettingsBox" id="doseContainer_' + i + '">\
            <div class="doseSettingsName">' + doseName[i] + '</div>\
            <div class="doseSettingsBox3">\
                <div class="doseSettingsAmountBox" style="margin-top:-10px;">\
                    <div class="doseSettingsAmountLabel">Reservoir</br>Capacity</div>\
                    <div class="doseSettingsAmount" id="doseReservoirSize_' + i + '">' + doseReservoirSize[i] +  ' ml</div>\
                </div>\
                <div class="parameterButtonBox">\
                    <button id="changeReservoirCapacityUp_' + i + '" onmousedown="changeReservoirCapacity(0,' + i + ')" class="doseUpDownButton bi bi-arrow-up-short"></button></br>\
                    <button id="changeReservoirCapacityDown_' + i + '" onmousedown="changeReservoirCapacity(1,' + i + ')" class="doseUpDownButton bi bi-arrow-down-short"></button>\
                </div>\
            </div>\
            <div class="doseSettingsBox3">\
                <div class="doseCalibrateButton buttonHover" onclick="calibrateDoser(' + i + ')">Calibrate</div>\
                <div style="margin-top: 13px;" class="doseSettingsAmountLabel">Pump Rate</div>\
                <div style="margin-top:-6px;" class="doseSettingsAmount">' + dosePumpRate[i] +  ' ms/ml</div>\
                <div class="doseStirrerEnableBox">\
                    <input type="checkbox" id="doseStirrer_' + i + '" onclick="enableDoseStirrer(' + i + ')">\
                    <label id="doseStirrerLabel_' + i + '" for="doseStirrer_' + i + '">Stirrer Enabled</label>\
                </div>\
            </div>\
            <div class="doseSettingsBox3" style="margin-top:10px; padding-top:10px; border-top:solid 1px rgb(80, 80, 80);">\
                <div class="doseSettingsAmountBox" style="margin-top:-10px;">\
                    <div class="doseSettingsAmountLabel">Minimum Delay</br>Between Doses</div>\
                    <div class="doseSettingsAmount" id="doseInterval_' + i + '" style="line-height: 1.1;">' + doseInterval[i] +  ' <span style="font-size:18px;">Minutes</span></div>\
                </div>\
                <div class="parameterButtonBox">\
                    <button id="changeDoseIntervalUp_' + i + '" onmousedown="changeDoseInterval(0,' + i + ')" class="doseUpDownButton bi bi-arrow-up-short"></button></br>\
                    <button id="changeDoseIntervalDown_' + i + '" onmousedown="changeDoseInterval(1,' + i + ')" class="doseUpDownButton bi bi-arrow-down-short"></button>\
                </div>\
            </div>\
        </div>';
    }
    document.getElementById('cleanScreen').innerHTML +=
        '<div class="widgetButtonBox">\
            <button class="button _48 back_48" style="margin-top:40px;" type="button" onclick="dosingSettings()"></button>\
        </div>';

    for (var i=0; i < doseID.length; i++)  // draw a reservoir for each dosing pump
    {
        if (doseStirrer[i] == 0) {
            document.getElementById('doseStirrer_' + i).checked = false; 
            document.getElementById('doseStirrerLabel_' + i).innerHTML = "Stirrer Disabled";
        }
        else if (doseStirrer[i] == 1) {
            document.getElementById('doseStirrer_' + i).checked = true;
            document.getElementById('doseStirrerLabel_' + i).innerHTML = "Stirrer Enabled";
        }

        var timeout;  // timer to track when button is held up or down
        var count = 0;
        var adjusted = 0;
        $('#changeDoseIntervalUp_' + i).mousedown(function () {  // action to take when mouse is down every 150ms
            timeout = setInterval(function () {
                adjusted = 1;
                changeDoseInterval(0, editingArrayID);
                count++;  // count each cycle while mouse button is down
                if (count > 10) {  // after 10 cycles increase cycle speed to 50ms
                    clearInterval(timeout); 
                    timeout = setInterval(function () {
                        changeDoseInterval(0, editingArrayID);
                        count++;
                        if (count > 60) {  // after 60 cycles increase cycle speed to 1ms
                            clearInterval(timeout);
                            timeout = setInterval(function () {
                                changeDoseInterval(0, editingArrayID);
                            }, 1);
                        }
                    }, 50);
                }
            }, 150);
        }).mouseup(function () {  // stop action when mouse is up
            count = 0;
            adjusted = 0;
            saveDoseInterval();
            clearInterval(timeout);
        }).mouseout(function () {  // stop action when mouse moves off up/down button
            count = 0;
            if (adjusted == 1) {saveDoseInterval();}
            adjusted = 0;
            clearInterval(timeout);
        });
        
        $('#changeDoseIntervalDown_' + i).mousedown(function () {  // action to take when mouse is down every 150ms
            timeout = setInterval(function () {
                adjusted = 1;
                changeDoseInterval(1, editingArrayID);
                count++;  // count each cycle while mouse button is down
                if (count > 10) {  // after 10 cycles increase cycle speed to 50ms
                    clearInterval(timeout); 
                    timeout = setInterval(function () {
                        changeDoseInterval(1, editingArrayID);
                        count++;
                        if (count > 60) {  // after 60 cycles increase cycle speed to 1ms
                            clearInterval(timeout);
                            timeout = setInterval(function () {
                                changeDoseInterval(1, editingArrayID);
                            }, 1);
                        }
                    }, 50);
                }
            }, 150);
        }).mouseup(function () {  // stop action when mouse is up
            count = 0;
            adjusted = 0;
            saveDoseInterval();
            clearInterval(timeout);
        }).mouseout(function () {  // stop action when mouse moves off up/down button
            count = 0;
            if (adjusted == 1) {saveDoseInterval();}
            adjusted = 0;
            clearInterval(timeout);
        });

        $('#changeReservoirCapacityUp_' + i).mousedown(function () {  // action to take when mouse is down every 150ms
            timeout = setInterval(function () {
                adjusted = 1;
                changeReservoirCapacity(0, editingArrayID);
                count++;  // count each cycle while mouse button is down
                if (count > 10) {  // after 10 cycles increase cycle speed to 50ms
                    clearInterval(timeout); 
                    timeout = setInterval(function () {
                        changeReservoirCapacity(0, editingArrayID);
                        count++;
                        if (count > 60) {  // after 60 cycles increase cycle speed to 1ms
                            clearInterval(timeout);
                            timeout = setInterval(function () {
                                changeReservoirCapacity(0, editingArrayID);
                            }, 1);
                        }
                    }, 50);
                }
            }, 150);
        }).mouseup(function () {  // stop action when mouse is up
            count = 0;
            adjusted = 0;
            saveReservoirCapacity();
            clearInterval(timeout);
        }).mouseout(function () {  // stop action when mouse moves off up/down button
            count = 0;
            if (adjusted == 1) {saveReservoirCapacity();}
            adjusted = 0;
            clearInterval(timeout);
        });
        
        $('#changeReservoirCapacityDown_' + i).mousedown(function () {  // action to take when mouse is down every 150ms
            timeout = setInterval(function () {
                adjusted = 1;
                changeReservoirCapacity(1, editingArrayID);
                count++;  // count each cycle while mouse button is down
                if (count > 10) {  // after 10 cycles increase cycle speed to 50ms
                    clearInterval(timeout); 
                    timeout = setInterval(function () {
                        changeReservoirCapacity(1, editingArrayID);
                        count++;
                        if (count > 60) {  // after 60 cycles increase cycle speed to 1ms
                            clearInterval(timeout);
                            timeout = setInterval(function () {
                                changeReservoirCapacity(1, editingArrayID);
                            }, 1);
                        }
                    }, 50);
                }
            }, 150);
        }).mouseup(function () {  // stop action when mouse is up
            count = 0;
            adjusted = 0;
            saveReservoirCapacity();
            clearInterval(timeout);
        }).mouseout(function () {  // stop action when mouse moves off up/down button
            count = 0;
            if (adjusted == 1) {saveReservoirCapacity();}
            adjusted = 0;
            clearInterval(timeout);
        });
    }
}

function calibrateDoser(arrayID) {  // calibration screen
    removeFooter();

    document.getElementById('content').innerHTML +=
        '<div class="cleanScreen" id="cleanScreen">\
        <div class="dosingPumpsBoxContainer" id="dosingPumpsBoxContainer"></div>\
        </div>';

    document.getElementById('dosingPumpsBoxContainer').innerHTML =
    '<div class="settingsTitle">Calibrating ' + doseName[arrayID] + '</div>\
    <div class="doseCalibrationContainer" id="">\
            <div class="doseCalibrationInstructions" id="">\
                To calibrate your dosing pump you\'ll need a small measuring vessel, ideally it\
                should be close to the actual amount you\'ll be dosing during regular use. If you work with large doses\
                you can start with a small measuring vessel, once calibration is close you can increase the dose amount along with your\
                measuring vessel and can fine tune.\
                </br></br>\
                <ul class="numberBullets">\
                    <li>On the right side set the\
                        <span class="doseCalibrationInstructionsHighlight">calibration amount</span> to match your measuring vessel.\
                    </li>\
                    <li>Press the "Manual Dose" Button.</li>\
                    <li>If the vessel has more than the\
                        <span class="doseCalibrationInstructionsHighlight">calibration amount</span> increase the\
                        <span class="doseCalibrationInstructionsHighlight">pump rate</span> or vice versa.\
                    </li>\
                    <li>Empty the vessel and repeat steps 2-3 until you get the correct dose.</li>\
                    <li>Once complete you can exit.</li>\
                </ul>\
            </div>\
            <div class="doseCalibrationSettings" id="">\
                <div class="doseSettingsBox2" style="padding-top:10px; width:220px;">\
                    <div class="doseSettingsAmountBox" style="width:145px;">\
                        <div class="doseSettingsAmountLabel">Calibration Amount</div>\
                        <div class="doseSettingsAmount" id="changeDoseCalibrationAmount">' + doseCalibrationAmount[arrayID] +  ' ml</div>\
                    </div>\
                    <div class="parameterButtonBox">\
                        <button id="changeDoseCalibrationAmountUp" onmousedown="changeDoseCalibrationAmount(0,' + arrayID + ')" class="doseUpDownButton bi bi-arrow-up-short"></button></br>\
                        <button id="changeDoseCalibrationAmountDown" onmousedown="changeDoseCalibrationAmount(1,' + arrayID + ')" class="doseUpDownButton bi bi-arrow-down-short"></button>\
                    </div>\
                </div>\
                <div class="doseSettingsBox2" style="padding-top:10px; width:218px; border-top: solid 2px rgb(72, 72, 72);">\
                    <div class="doseSettingsAmountBox" style="width:145px;">\
                        <div class="doseSettingsAmountLabel">Pump Rate</div>\
                        <div class="doseSettingsAmount" id="changeDosePumpRate">' + dosePumpRate[arrayID] +  ' ms/ml</div>\
                    </div>\
                    <div class="parameterButtonBox">\
                        <button id="changePumpRateUp" onmousedown="changePumpRate(0,' + arrayID + ')" class="doseUpDownButton bi bi-arrow-up-short"></button></br>\
                        <button id="changePumpRateDown" onmousedown="changePumpRate(1,' + arrayID + ')" class="doseUpDownButton bi bi-arrow-down-short"></button>\
                    </div>\
                </div>\
            </div>\
    </div>';

    document.getElementById('dosingPumpsBoxContainer').innerHTML += 
        '<div class="widgetButtonBox">\
            <button class="button _wide" type="button" onclick="manualDoseCalibrate(`' + arrayID + '`)">Manual Dose</button>\
            <button class="button _wide" type="button" onclick="dosingSettings2()">Finished</button>\
        </div></br>';
        // <button class="button" onclick="manualDoseCalibrate(' + arrayID + ')";>Manual Dose</button>\
        // <button class="button exit" onclick="dosingSettings2(); doseCalibrationDone(' + arrayID + ');">Finished</button>';

    // press and hold when changing calibration dose amount
    var timeout;  // timer to track when button is held up or down
    var count = 0;
    var adjusted = 0;
    $('#changeDoseCalibrationAmountUp').mousedown(function () {  // action to take when mouse is down every 150ms
        timeout = setInterval(function () {
            adjusted = 1;
            changeDoseCalibrationAmount(0, editingArrayID);
            count++;  // count each cycle while mouse button is down
            if (count > 10) {  // after 10 cycles increase cycle speed to 50ms
                clearInterval(timeout); 
                timeout = setInterval(function () {
                    changeDoseCalibrationAmount(0, editingArrayID);
                    count++;
                    if (count > 60) {  // after 60 cycles increase cycle speed to 1ms
                        clearInterval(timeout);
                        timeout = setInterval(function () {
                            changeDoseCalibrationAmount(0, editingArrayID);
                        }, 1);
                    }
                }, 50);
            }
        }, 150);
    }).mouseup(function () {  // stop action when mouse is up
        count = 0;
        adjusted = 0;
        saveCalibrationAmount();
        clearInterval(timeout);
    }).mouseout(function () {  // stop action when mouse moves off up/down button
        count = 0;
        if (adjusted == 1) {saveCalibrationAmount();}
        adjusted = 0;
        clearInterval(timeout);
    });
    
    $('#changeDoseCalibrationAmountDown').mousedown(function () {  // action to take when mouse is down every 150ms
        timeout = setInterval(function () {
            adjusted = 1;
            changeDoseCalibrationAmount(1, editingArrayID);
            count++;  // count each cycle while mouse button is down
            if (count > 10) {  // after 10 cycles increase cycle speed to 50ms
                clearInterval(timeout); 
                timeout = setInterval(function () {
                    changeDoseCalibrationAmount(1, editingArrayID);
                    count++;
                    if (count > 60) {  // after 60 cycles increase cycle speed to 1ms
                        clearInterval(timeout);
                        timeout = setInterval(function () {
                            changeDoseCalibrationAmount(1, editingArrayID);
                        }, 1);
                    }
                }, 50);
            }
        }, 150);
    }).mouseup(function () {  // stop action when mouse is up
        count = 0;
        adjusted = 0;
        saveCalibrationAmount();
        clearInterval(timeout);
    }).mouseout(function () {  // stop action when mouse moves off up/down button
        count = 0;
        if (adjusted == 1) {saveCalibrationAmount();}
        adjusted = 0;
        clearInterval(timeout);
    });
    
    // press and hold when changing pump rate
    $('#changePumpRateUp').mousedown(function () {  // action to take when mouse is down every 150ms
        timeout = setInterval(function () {
            adjusted = 1;
            changePumpRate(0, editingArrayID);
            count++;  // count each cycle while mouse button is down
            if (count > 10) {  // after 10 cycles increase cycle speed to 50ms
                clearInterval(timeout); 
                timeout = setInterval(function () {
                    changePumpRate(0, editingArrayID);
                    count++;
                    if (count > 60) {  // after 60 cycles increase cycle speed to 1ms
                        clearInterval(timeout);
                        timeout = setInterval(function () {
                            changePumpRate(0, editingArrayID);
                        }, 1);
                    }
                }, 50);
            }
        }, 150);
    }).mouseup(function () {  // stop action when mouse is up
        count = 0;
        adjusted = 0;
        savePumpRate();
        clearInterval(timeout);
    }).mouseout(function () {  // stop action when mouse moves off up/down button
        count = 0;
        if (adjusted == 1) {savePumpRate();}
        adjusted = 0;
        clearInterval(timeout);
    });
    
    $('#changePumpRateDown').mousedown(function () {  // action to take when mouse is down every 150ms
        timeout = setInterval(function () {
            adjusted = 1;
            changePumpRate(1, editingArrayID);
            count++;  // count each cycle while mouse button is down
            if (count > 10) {  // after 10 cycles increase cycle speed to 50ms
                clearInterval(timeout); 
                timeout = setInterval(function () {
                    changePumpRate(1, editingArrayID);
                    count++;
                    if (count > 60) {  // after 60 cycles increase cycle speed to 1ms
                        clearInterval(timeout);
                        timeout = setInterval(function () {
                            changePumpRate(1, editingArrayID);
                        }, 1);
                    }
                }, 50);
            }
        }, 150);
    }).mouseup(function () {  // stop action when mouse is up
        count = 0;
        adjusted = 0;
        savePumpRate();
        clearInterval(timeout);
    }).mouseout(function () {  // stop action when mouse moves off up/down button
        count = 0;
        if (adjusted == 1) {savePumpRate();}
        adjusted = 0;
        clearInterval(timeout);
    });

    // $('.exit').click(function() 
    // {
    //     dosingSettings2();
    // })
}

function changeReservoirColor(picker, arrayID) {  // 
    // console.log('picker =============== ' + picker.toString()); 
    var color = picker.toString();
    
    $('#doseTubeDiv_' + [arrayID]).css('background','linear-gradient(90deg, ' + color + ' 100%, white 00%)');
    $('#doseTubeDiv_' + [arrayID]).css('background-repeat', 'no-repeat');
    doseReservoirColor[arrayID] = color;
    doseFillReservoirSettings(arrayID);
}

function saveReservoirColor(picker, arrayID) {  // 
    console.log('saveReservoirColor =============== ' + picker.toString()); 
    $.ajax({  // save sort type to database
        method: "POST",
        url: "/php/dosingSaveReservoirColor.php",
        dataType: "text/plain",
        data: {
            "i": doseID[arrayID],
            "c": picker.toString(),
        }
    });
}

function changeDosingName(arrayID)  // refill reservoir
{
    console.log('changeDosingName =============== ' + arrayID);
    // doseName[arrayID] = "test";
    
    var divExists = document.getElementById("doseSettingsName_" + arrayID);  // check if div ID is drawn
    if(divExists){
        document.getElementById('doseSettingsName_' + arrayID).innerHTML = 
            '<input class="editDoserName" type="text" id="editDoserName" value="' + doseName[arrayID] + '" onfocusout="saveDosingName(' + arrayID + ')" autocomplete="off">\
            <i class="bi bi-check saveCheckmark" id="saveCheckmark" onclick="saveDosingName(' + arrayID + ')"></i>';
        // document.getElementById('editDoserName').focus();
        document.getElementById('editDoserName').select();

        document.getElementById("editDoserName")
            .addEventListener("keyup", function(event) {  // save name if enter key is pressed while editing
                event.preventDefault();
                if (event.keyCode === 13) {  // enter key
                    document.getElementById("saveCheckmark").click();
                }
            });
    }
}

function saveDosingName(arrayID)  // refill reservoir
{
    console.log('saveDosingName =============== ' + arrayID);
    var divExists = document.getElementById("doseSettingsName_" + arrayID);  // check if div ID is drawn
    if(divExists){
        doseName[arrayID] = document.getElementById('editDoserName').value;
        
        console.log('doseName = ' + doseName[arrayID]);
        document.getElementById('doseSettingsName_' + arrayID).innerHTML = 
            doseName[arrayID] + '<i class="bi bi-pencil-fill editPencil" onclick="changeDosingName(' + arrayID + ')"></i>';

        $.ajax({  // save custom name
            method: "POST",
            url: "/php/dosingSaveName.php",
            dataType: "text/plain",
            data: {
                "i": doseID[arrayID],
                "p": dosePinID[arrayID],
                "n": doseName[arrayID]
            }
        });
    }
}

function changeDoseAmount(direction, arrayID) {  // change dose amount
    // console.log('changeDoseAmount =============== ' + arrayID); 
    editingArrayID = arrayID;  // capature arrayID being adjusted so we can use to hold button down to increase/decrease value
    if (direction == 0) {
        doseAmount[arrayID]++;
        if (doseAmount[arrayID] > doseReservoirSize[arrayID]) {doseAmount[arrayID] = 1;}
        // if (doseAmount[arrayID] < doseReservoirSize[arrayID]) {doseAmount[arrayID]++;}
        // else {doseAmount[arrayID] = 1;}
        
        if (doseAmount[arrayID] > doseReservoirSize[arrayID]) {doseAmount[arrayID] = 1;}
    }
    else if (direction == 1) {
        doseAmount[arrayID]--; 
        // if ((doseAmount[arrayID] <= 0) && (doseAmount[arrayID] <= doseReservoirSize[arrayID])) {
        if (doseAmount[arrayID] <= 0) {doseAmount[arrayID] = doseReservoirSize[arrayID];}
        else if (doseAmount[arrayID] <= 0) {doseAmount[arrayID] = 2000;}
    }    

    document.getElementById('doseSettingsAmount_' + arrayID).innerHTML = doseAmount[arrayID] + " ml";

    doseRemaining[arrayID] = Math.floor((doseReservoirRemain[arrayID] / doseAmount[arrayID]));
    document.getElementById('doseRemainingDiv_' + arrayID).innerHTML = doseRemaining[arrayID] + " Doses Remaining";
}

function saveDoseAmount()  // save dose amount
{
    console.log('saveDoseAmount =============== ' + editingArrayID);
    console.log('doseAmount[arrayID] =============== ' + doseAmount[editingArrayID]);

    var command = "81, " + dosePinID[editingArrayID] + "," + doseAmount[editingArrayID];
    sendToBackend(command);  // tell backend I/O pins have changed
    console.log('command =============== ' + command);
}

function changeDoseInterval(direction, arrayID) {  // change minimum interval between doses
    // console.log('changeDoseInterval =============== ' + arrayID); 
    editingArrayID = arrayID;  // capature arrayID being adjusted so we can use to hold button down to increase/decrease value

    if (direction == 0) {  // up
        doseInterval[arrayID]++;
        if (doseInterval[arrayID] >= 10000) {doseInterval[arrayID] = 0;}
    }
    else if (direction == 1) {  // down
        doseInterval[arrayID]--;
        if (doseInterval[arrayID] < 0) {doseInterval[arrayID] = 9999;}
    }
    document.getElementById('doseInterval_' + arrayID).innerHTML = doseInterval[arrayID] + ' <span style="font-size:18px;">Minutes</span>';

    // if (doseReservoirSize[arrayID] < doseReservoirRemain[arrayID]) {refillDoseReservoir(arrayID);}
}

function saveDoseInterval()  // minimum interval between doses
{
    console.log('saveDoseInterval =============== ' + editingArrayID);
    console.log('doseInterval[arrayID] ========== ' + doseInterval[editingArrayID]);
    
    var command = "89, " + dosePinID[editingArrayID] + "," + doseInterval[editingArrayID];
    sendToBackend(command);  // tell backend I/O pins have changed
    console.log('command =============== ' + command);
}

function changeReservoirCapacity(direction, arrayID) {  // 
    // console.log('changeReservoirCapacity =============== ' + arrayID); 
    editingArrayID = arrayID;  // capature arrayID being adjusted so we can use to hold button down to increase/decrease value

    if (direction == 0) {  // up
        doseReservoirSize[arrayID]++;
        if (doseReservoirSize[arrayID] >= 10000) {doseReservoirSize[arrayID] = 1;}
    }
    else if (direction == 1) {  // down
        doseReservoirSize[arrayID]--;
        if (doseReservoirSize[arrayID] <= 0) {doseReservoirSize[arrayID] = 9999;}
    }
    document.getElementById('doseReservoirSize_' + arrayID).innerHTML = doseReservoirSize[arrayID] + " ml";

    // if (doseReservoirSize[arrayID] < doseReservoirRemain[arrayID]) {refillDoseReservoir(arrayID);}
}

function saveReservoirCapacity()  // save reservoir capacity
{
    console.log('saveReservoirCapacity =============== ' + editingArrayID);
    console.log('doseReservoirSize[arrayID] ========== ' + doseReservoirSize[editingArrayID]);
    
    var command = "82, " + dosePinID[editingArrayID] + "," + doseReservoirSize[editingArrayID];
    sendToBackend(command);  // tell backend I/O pins have changed
    console.log('command =============== ' + command);

    setTimeout(function() {refillDoseReservoir(editingArrayID);},200);
}

function enableDoseStirrer(arrayID) {  // 
    console.log('enableDoseStirrer =============== ' + arrayID); 
    var enab = document.getElementById('doseStirrer_' + arrayID).value;
    console.log('enab = ' + enab); 

    if (doseStirrer[arrayID] == 0) {
        doseStirrer[arrayID] = 1;
        document.getElementById('doseStirrerLabel_' + arrayID).innerHTML = "Stirrer Enabled";
    }
    else if (doseStirrer[arrayID] == 1) {
        doseStirrer[arrayID] = 0;
        document.getElementById('doseStirrerLabel_' + arrayID).innerHTML = "Stirrer Disabled";
    }    

    var command = "84, " + dosePinID[editingArrayID] + "," + doseStirrer[editingArrayID];
    sendToBackend(command);  // tell backend I/O pins have changed
    console.log('command =============== ' + command);
}

function refillDoseReservoir(arrayID)  // refill reservoir
{
    console.log('refillDoseReservoir =============== ' + arrayID); 
    doseReservoirRemain[arrayID] = doseReservoirSize[arrayID];
    doseRemaining[arrayID] = Math.floor((doseReservoirRemain[arrayID] / doseAmount[arrayID]));

    var divExists = document.getElementById("doseReservoirSize_" + arrayID);  // check if div ID is drawn
    if (!divExists) {divExists = document.getElementById("doseSettingsName_" + arrayID);}
    console.log('divExists =============== ' + divExists); 
    if(divExists){
        console.log('PASS =============== '); 
    
        doseFillReservoirSettings(arrayID);

        var command = "86, " + dosePinID[arrayID];
        sendToBackend(command);  // tell backend I/O pins have changed
        console.log('command =============== ' + command);

        document.getElementById('doseRemainingDiv_' + arrayID).innerHTML = doseRemaining[arrayID] + " Doses Remaining";
    }
}

function changePumpRate(direction, arrayID) {  // change dose amount
    // console.log('changePumpRate =============== ' + arrayID); 
    editingArrayID = arrayID;  // capature arrayID being adjusted so we can use to hold button down to increase/decrease value
    if (direction == 0) {
        dosePumpRate[arrayID]++;
        if (dosePumpRate[arrayID] > 2000) {dosePumpRate[arrayID] = 1;}
    }
    else if (direction == 1) {
        dosePumpRate[arrayID]--;
        if (dosePumpRate[arrayID] <= 0) {dosePumpRate[arrayID] = 2000;}
    }    

    document.getElementById('changeDosePumpRate').innerHTML = dosePumpRate[arrayID] + " ms/ml";
}

function savePumpRate()  // save pump rate
{
    console.log('savePumpRate =============== ' + editingArrayID);
    console.log('dosePumpRate =============== ' + dosePumpRate[editingArrayID]);

    var command = "83, " + dosePinID[editingArrayID] + "," + dosePumpRate[editingArrayID];
    sendToBackend(command);  // tell backend I/O pins have changed
    console.log('command =============== ' + command);
}

function changeDoseCalibrationAmount(direction, arrayID) {  // change dose amount
    console.log('changeDoseCalibrationAmount =============== ' + direction); 
    editingArrayID = arrayID;  // capature arrayID being adjusted so we can use to hold button down to increase/decrease value
    if (direction == 0) {
        doseCalibrationAmount[arrayID]++;
        if (doseCalibrationAmount[arrayID] > 1000) {doseCalibrationAmount[arrayID] = 1;}
    }
    else if (direction == 1) {
        doseCalibrationAmount[arrayID]--; 
        if (doseCalibrationAmount[arrayID] <= 0) {doseCalibrationAmount[arrayID] = 1;}
    }    

    document.getElementById('changeDoseCalibrationAmount').innerHTML = doseCalibrationAmount[arrayID] + " ml";

}

function saveCalibrationAmount() {  // change dose amount
    // console.log('changeDoseCalibrationAmount =============== ' + direction); 
    console.log('saveCalibrationAmount =============== ' + editingArrayID);
    console.log('doseCalibrationAmount =============== ' + doseCalibrationAmount[editingArrayID]);
    

    var command = "85, " + dosePinID[editingArrayID] + "," + doseCalibrationAmount[editingArrayID];
    sendToBackend(command);  // tell backend I/O pins have changed
    console.log('command =============== ' + command);
}

function manualDose(arrayID) {  // manually dose
    console.log('manualDose =============== ' + arrayID);
    
    if (doseRemaining[arrayID] > 0) {
        var command = "80, " + dosePinID[arrayID];
        sendToBackend(command);  // tell backend I/O pins have changed
        console.log('command =============== ' + command);

        doseReservoirRemain[arrayID] = doseReservoirRemain[arrayID] - doseAmount[arrayID];
        doseRemaining[arrayID] = Math.floor((doseReservoirRemain[arrayID] / doseAmount[arrayID]));
        document.getElementById('doseRemainingDiv_' + arrayID).innerHTML = doseRemaining[arrayID] + " Doses Remaining";
    }
    else {document.getElementById('doseRemainingDiv_' + arrayID).innerHTML = "Low Reservoir - REFILL";}
    

    doseFillReservoirSettings(arrayID);
}

function doseFillReservoirSettings(arrayID)  // calculate how much remains in reservoir
{
    // full reservoir = position 24px and size 113px
    // empty reservoir = position 136px and size 1px
    // full scale is 112px
    // 1% = 1.12px
    dosePercentageRemaining[arrayID] = (doseReservoirRemain[arrayID] / doseReservoirSize[arrayID]) * 100;
    var position = (136 - (dosePercentageRemaining[arrayID] * 1.12)) + "px";
    var size = (1 + (dosePercentageRemaining[arrayID] * 1.12)) + "px";
    var size2 = (1 + (dosePercentageRemaining[arrayID] * 1.05)) + "px";
    var divExists = document.getElementById("doseTubeDiv_" + arrayID);  // check if div ID is drawn
    if(divExists){
        document.getElementById('doseTubeDiv_' + [arrayID]).style.backgroundPosition = "7px " + position;  // set background position
        document.getElementById('doseTubeDiv_' + [arrayID]).style.backgroundSize = "32px " + size;  // set background size

        document.getElementById('doseClickColor_' + [arrayID]).style.height = size2;  // set background size
        document.getElementById('doseClickColor_' + [arrayID]).style.marginTop = "-" + size2;  // set background size
    }
}

function manualDoseCalibrate(arrayID) {  // manually dose during calibration
    console.log('manualDoseCalibrate =============== ' + arrayID);
    
    var command = "87, " + dosePinID[arrayID];
    sendToBackend(command);  // tell backend I/O pins have changed
    console.log('command =============== ' + command);

}

function doseCalibrationDone(arrayID) {  // calibration finished
    console.log('doseCalibrationDone =============== ' + arrayID);
    
    var command = "88," + dosePinID[arrayID];
    sendToBackend(command);  // tell backend I/O pins have changed
    console.log('command =============== ' + command);
}

function updateDosingStatus(id, value) {  // update dosing port status as data comes in from backend
    // console.log("updateDosingStatus = " + id + ", " + value);
    for (var i=0; i < dosePinID.length; i++) {
        if (dosePinID[i] == id) {
            // console.log("doseStatus = " + doseStatus[i]);

            if (value == 1) {  // stirring
                doseStatus[i] = value;  // record new state
                document.getElementById('doseTubeDiv_' + i).style.color = "#FF0000";
        
                document.getElementById('doseTubeDiv_' + i).innerHTML =
                '<span id="doseRemainingDiv_' + i + '">Stirring</span></br>\
                <div id="doseClickColor_' + i + '"></div>\
                <img class="reservoirImage" height="130px;" src="images/icons/doseReservoir_Red.png">';
            }
            else if (value == 2) {  // settling
                doseStatus[i] = value;  // record new state
                document.getElementById('doseTubeDiv_' + i).style.color = "#FF0000";
        
                document.getElementById('doseTubeDiv_' + i).innerHTML =
                '<span id="doseRemainingDiv_' + i + '">Settling</span></br>\
                <div id="doseClickColor_' + i + '"></div>\
                <img class="reservoirImage" height="130px;" src="images/icons/doseReservoir_Red.png">';
            }
            else if (value == 3) {  // dosing
                doseStatus[i] = value;  // record new state
                document.getElementById('doseTubeDiv_' + i).style.color = "#FF0000";
        
                document.getElementById('doseTubeDiv_' + i).innerHTML =
                '<span id="doseRemainingDiv_' + i + '">Dosing</span></br>\
                <div id="doseClickColor_' + i + '"></div>\
                <img class="reservoirImage" height="130px;" src="images/icons/doseReservoir_Red.png">';
            }
            else if ((doseStatus[i] == 3) && (value == 0)) {  // finished
                doseStatus[i] = value;  // record new state
                doseReservoirRemain[i] = doseReservoirRemain[i] - doseAmount[i];
                doseRemaining[i] = Math.floor((doseReservoirRemain[i] / doseAmount[i]));
                doseFillReservoirSettings(i);
        
                document.getElementById('doseTubeDiv_' + i).style.color = "#FFFFFF";

                document.getElementById('doseTubeDiv_' + i).innerHTML =
                '<span id="doseRemainingDiv_' + i + '">' + doseRemaining[i] + '</span></br>\
                <div id="doseClickColor_' + i + '"></div>\
                <img class="reservoirImage" height="130px;" src="images/icons/doseReservoir_White.png">';
            }

            break;
        }
    }



    if (displayScreen == 0) {  // dashboard

    }
}